unit UQuerys;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, DB, DBTables, Menus;

type
  TFmQuerys = class(TForm)
    DBQueryList: TListBox;
    Splitter1: TSplitter;
    DBFieldList: TListBox;
    PMNewDS: TPopupMenu;
    NewItem: TMenuItem;
    procedure DBQueryListClick(Sender: TObject);
    procedure NewItemClick(Sender: TObject);
    procedure DBFieldListStartDrag(Sender: TObject;
      var DragObject: TDragObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
   procedure UpdateQuery(AComp: TComponent);
  end;

var
  FmQuerys: TFmQuerys;

implementation

uses Main, Childwin;

{$R *.DFM}

procedure TFmQuerys.UpdateQuery(AComp: TComponent);
var List: TStrings;
    I: Integer;
begin
    if AComp = Nil then
    begin
     DBQueryList.clear;
     DBFieldList.clear;
     exit;
    end;

    List := TStringList.create;
    try
     for I := 0 to AComp.ComponentCount - 1 do
      if AComp.Components[I] is TQuery then
       List.AddObject(AComp.Components[I].Name,AComp.Components[I]);
    DBQueryList.Items.Assign(List);
    DBFieldList.clear;
    finally
    List.free;
    end;
end;

procedure TFmQuerys.DBQueryListClick(Sender: TObject);
var I: Integer;
begin
if DBQueryList.ItemIndex > -1 then
   begin
   TQuery(DBQueryList.Items.Objects[DBQueryList.ItemIndex]).GetFieldNames(DBFieldList.Items);
   for I := 0 to DBFieldList.Items.Count - 1 do
   DBFieldList.Items.Objects[I] := DBQueryList.Items.Objects[DBQueryList.ItemIndex];

   I := DBQueryList.ItemIndex;


   if TMDIChild(TMainForm(Owner).ActiveMDIChild).Handles.Attached then
   begin
   TMDIChild(TMainForm(Owner).ActiveMDIChild).Handles.Detach;
   // Once again
   DBQueryList.SetFocus;
   DBQueryList.ItemIndex := I;
   DBQueryListClick(Sender);
   end;


   end else
   DBFieldList.Items.Clear;
end;

procedure TFmQuerys.NewItemClick(Sender: TObject);
begin
TMDIChild(TMainForm(Owner).ActiveMDIChild).EditDatasets;
end;

procedure TFmQuerys.DBFieldListStartDrag(Sender: TObject;
  var DragObject: TDragObject);
var I: Integer;
begin
   for I := 0 to TMDIChild(TMainForm(Owner).ActiveMDIChild).CWReport.ReportPageCount -1 do
    TMDIChild(TMainForm(Owner).ActiveMDIChild).CWReport.ReportPages[I].OnDragOver :=
    TMDIChild(TMainForm(Owner).ActiveMDIChild).FormDragOver;
end;

end.
